import sys

class Tree():
    # """
    # The binary search tree.
    # """

    def __init__(self, root=None):
        self.root = root

    # def __str__(self):
    #    return "Binary tree with root of " + str(self.root)


class Node():
    # """
    # The nodes in our binary search tree.
    # """

    def __init__(self, k):
        # """
        #     Args:
        #         k: this node's key
        #     Returns:
        #         None
        # """
        self.key = k
        self.left = None
        self.right = None

    # def __str__(self):
    #    return str(self.key)


def tree_insert(x, z):
    # """
    # Insert a node in a bst.
    # Args:
    #     x: the subtree in which to insert
    #     z: the node to insert
    # Return:
    #     root
    # """
    if x is None:
        return z
    elif x.key > z.key:
        x.left = tree_insert(x.left, z)
    else:
        x.right = tree_insert(x.right, z)

    return x


def tree_search(x, k):
    # """
    #     Recursively searches a binary tree for a particular key.
    #     Args:
    #         x: the node at which to start the search
    #     Returns:
    #         None, or the node containing the key.
    # """
    if x is None:
        return None
    elif k == x.key:
        return x
    elif k < x.key:
        return tree_search(x.left, k)
    else:
        return tree_search(x.right, k)


def test_search():
    with open(sys.argv[1]) as file:
        file = file.read().split("\n")
        tree = Tree()
        for data in file:
            data = data.split("\t")
            # print(data, len(data))
            data[1] = int(data[1])
            if data[0] == "I":
                tree.root = tree_insert(tree.root, Node(data[1]))
            else:
                node = tree_search(tree.root, data[1])
                if node:
                    print(node.key, "found")
                else:
                    print(data[1], "not found")


test_search()