import sys

# minimum degree
t = 4

class Tree():
    # """
    # The binary search tree.
    # """
    def __init__(self, root=None):
        self.root = Node()

class Node():
    # """
    # The nodes in our btree.
    # """
    def __init__(self):
        self.n = 0
        self.key = [None for _ in range(2 * t)]
        self.child = [None for _ in range(2 * t + 1)]
        self.leaf = True


def tree_split_child(x, i):
    z = Node()
    y = x.child[i]
    z.leaf = y.leaf
    z.n = t - 1
    for j in range(t - 1):
        z.key[j] = y.key[j + t]
    if not y.leaf:
        for j in range(t):
            z.child[j] = y.child[j + t]
    y.n = t - 1
    for j in range(x.n, i, -1):
        x.child[j + 1] = x.child[j]
    x.child[i + 1] = z
    for j in range(x.n - 1, i - 1, -1):
        x.key[j + 1] = x.key[j]
    x.key[i] = y.key[t - 1]
    x.n = x.n + 1


def tree_insert_nonfull(x, k):
    i = x.n - 1
    if x.leaf:
        while (i >= 0 and k < x.key[i]):
            x.key[i + 1] = x.key[i]
            i -= 1
        x.key[i + 1] = k
        x.n += 1
    else:
        while (i >= 0 and k < x.key[i]):
            i -= 1
        i += 1
        if x.child[i].n == 2 * t - 1:
            tree_split_child(x, i)
            if k > x.key[i]:
                i += 1
        tree_insert_nonfull(x.child[i], k)


def tree_insert(tree, k):
    r = tree.root
    if r.n == 2 * t - 1:
        s = Node()
        tree.root = s
        s.leaf = False
        s.child[0] = r
        tree_split_child(s, 0)
        tree_insert_nonfull(s, k)
    else:
        tree_insert_nonfull(r, k)


def tree_search(x, k):
    # """
    #     Recursively searches a btree for a particular key.
    #     Args:
    #         x: the node at which to start the search
    #     Returns:
    #         None, or the node containing the key.
    # """
    i = 0
    # print(x.leaf)
    while (i < x.n and k > x.key[i]):
        i += 1
    if i < x.n and k == x.key[i]:
        return (x, i)
    elif x.leaf:
        return None
    else:
        return tree_search(x.child[i], k)


def test_search():
    with open(sys.argv[1]) as file:
        file = file.read().split("\n")
        tree = Tree()
        for data in file:
            data = data.split("\t")
            # print(data, len(data))
            data[1] = int(data[1])
            if data[0] == "I":
                tree_insert(tree, data[1])
            else:
                node = tree_search(tree.root, data[1])
                if node:
                    print(node[0].key, "at index", node[1], "found", data[1])
                else:
                    print(data[1], "not found")


test_search()