import sys
import os
import graph_utils

######################################################################
# graph reachability using sets and loops, iterative, not incrementalized
######################################################################

# returns set of vertices reachable from vertices in s following edges in e.
# e is a set of edge, in the form of pairs of start and end vertices.
# s is a set of vertices.


def reach_iter(e,s):
    r = s
    while {y for (x,y) in e if x in s and y not in r}:      # while exists x in
        x={y for (x,y) in e if x in s and y not in r}.pop() #   {...}
        r.add(x)
    return r

def run_reach():

    s, e= graph_utils.read_graph_input(input_file)

    print('s =', s)
    print('e =',e)
    print('reach_iter =', reach_iter(e,s))

input_file = sys.argv[1] if len(sys.argv) > 1 else "graph.txt"
if os.path.exists(input_file):
    run_reach()
else:
    print('Please specify a valid input file.')
    exit(1)