import plotly as py
import plotly.graph_objs as go


def createHeatMap(data, data2, name, g1, g2, vfile):
    list = []
    for x in name:
        list.append((x.split('\\'))[-1])
    data1 = go.Heatmap(
        z=data,
        x=list,
        y=list,
        showscale=False
    )

    data2 = go.Heatmap(
        z=data2,
        x=list,
        y=list,
        showscale=False
    )
    data3 = go.Bar(
        x=list,
        y=g1,
        showlegend=False
    )

    data4 = go.Bar(
        x=list,
        y=g2,
        showlegend=False
    )

    data = [data1, data2, data3, data4]

    #fig = go.Figure(data=data, layout = layout)
    #py.offline.plot(fig, filename=vfile)

    fig = py.tools.make_subplots(rows=2, cols=2, subplot_titles=(
        'Pairwise Jaccard', 'Pairwise Smith', 'Group Jaccard', 'Shared Fraction'), print_grid=False, horizontal_spacing=0.20)
    fig.append_trace(data1, 1, 1)
    fig.append_trace(data2, 1, 2)
    fig.append_trace(data3, 2, 1)
    fig.append_trace(data4, 2, 2)

    fig['layout'].update(height=900, width=1200, title='Pairwise comparison')
    py.offline.plot(fig, filename=vfile)
